Index: program/js/app.js
===================================================================
--- program/js/app.js	(revision 360)
+++ program/js/app.js	(working copy)
@@ -118,7 +118,7 @@
           this.message_list.row_init = function(o){ p.init_message_row(o); };
           this.message_list.addEventListener('dblclick', function(o){ p.msglist_dbl_click(o); });
           this.message_list.addEventListener('keypress', function(o){ p.msglist_keypress(o); });
-          this.message_list.addEventListener('select', function(o){ p.msglist_select(o); });
+          this.message_list.addEventListener('select', function(o){ p.msglist_select(o); p.list_display_details(o) });
           this.message_list.addEventListener('dragstart', function(o){ p.drag_active = true; });
           this.message_list.addEventListener('dragend', function(o){ p.drag_active = false; });
 
@@ -194,17 +194,20 @@
       case 'addressbook':
         if (this.gui_objects.contactslist)
           {
-          this.contact_list = new rcube_list_widget(this.gui_objects.contactslist, {multiselect:true, draggable:false, keyboard:true});
+          this.contact_list = new rcube_list_widget(this.gui_objects.contactslist, {multiselect:true, draggable:true, keyboard:true});
           this.contact_list.addEventListener('keypress', function(o){ p.contactlist_keypress(o); });
-          this.contact_list.addEventListener('select', function(o){ p.contactlist_select(o); });
+          this.contact_list.addEventListener('dblclick', function(o){ p.contactlist_dbl_click(o); });
+          this.contact_list.addEventListener('select', function(o){ p.contactlist_select(o); p.list_display_details(o)});
+          this.contact_list.addEventListener('dragstart', function(o){ p.drag_active = true; });
+          this.contact_list.addEventListener('dragend', function(o){ p.drag_active = false; });
           this.contact_list.init();
 
           if (this.env.cid)
             this.contact_list.highlight_row(this.env.cid);
 
-          if (this.gui_objects.contactslist.parentNode)
+          if (this.gui_objects.contactslist)
             {
-            this.gui_objects.contactslist.parentNode.onmousedown = function(e){ return p.click_on_list(e); };
+            this.gui_objects.contactslist.onmousedown = function(e){ return p.click_on_list(e); };
             document.onmouseup = function(e){ return p.doc_mouse_up(e); };
             }
           else
@@ -219,10 +222,20 @@
         if ((this.env.action=='add' || this.env.action=='edit') && this.gui_objects.editform)
           this.enable_command('save', true);
 
-        this.enable_command('list', 'add', true);
-
-        // this.enable_command('ldappublicsearch', this.env.ldappublicsearch);
-
+        this.enable_command('list', true);
+        this.enable_command('add', true);
+        this.enable_command('search', true);
+        this.enable_command('reset-search', true);
+        this.enable_command('addgroup',true);
+        this.enable_command('moveto' ,true);
+        this.enable_command('send-vcard', true);
+        this.enable_command('cancel-vcard', true);
+        this.enable_command('vcard', true);
+        this.enable_command('ldappublicsearch', this.env.ldappublicsearch);
+        
+        if(!this.env.mbox)
+          this.select_groupbox('all');
+          
         break;
 
 
@@ -433,11 +446,10 @@
           {
           if (this.env.search_request<0 || (this.env.search_request && props != this.env.mailbox))
             this.reset_qsearch();
-
-          this.list_mailbox(props);
+            this.list_mailbox(props);
           }
         else if (this.task=='addressbook')
-          this.list_contacts();
+          this.list_contacts(props);   // added props to be passed to function
         break;
 
 
@@ -597,7 +609,12 @@
       // mail task commands
       case 'move':
       case 'moveto':
-        this.move_messages(props);
+      
+        if (this.task=='mail')
+          this.move_messages(props);
+        else if (this.task=='addressbook')
+          this.move_contacts(props);
+          
         break;
         
       case 'toggle_status':
@@ -827,16 +844,22 @@
         if (!props && this.gui_objects.qsearchbox)
           props = this.gui_objects.qsearchbox.value;
         if (props)
-          this.qsearch(urlencode(props), this.env.mailbox);
+        {
+          if(this.task=='mail')
+            this.qsearch(urlencode(props), this.env.mailbox);
+          else if(this.task=='addressbook')
+            this.qsearch(urlencode(props), this.env.mbox);
+        }
+          
         break;
 
       // reset quicksearch        
       case 'reset-search':
         var s = this.env.search_request;
         this.reset_qsearch();
-        
         if (s)
           this.list_mailbox(this.env.mailbox);
+        
         break;
 
       // ldap search
@@ -846,8 +869,28 @@
         else 
           this.ldappublicsearch(command);
         break; 
+      
+      case 'vcard':
+          this.vcard_form(command);
+        break;
+      
+      case 'send-vcard':
+        this.upload_vcard(props);
+        break;
+        
+      case 'cancel-vcard':
+        // Reset the display
+        history.back(); 
+        break;
+        
+      case 'addgroup':
+        this.show_group_form(true);
+        break;
+         
+      case 'removegroup':
+         this.remove_group(this.env.mbox);
+         break;
 
-
       // user settings commands
       case 'preferences':
         this.goto_url('');
@@ -1016,7 +1059,7 @@
     if (this.message_list)
       this.message_list.focus();
     else if (this.contact_list)
-        this.contact_list.focus();
+      this.contact_list.focus();
 
     var mbox_li;
     if (mbox_li = this.get_mailbox_li())
@@ -1061,7 +1104,6 @@
     };
 
 
-
   /*********************************************************/
   /*********     (message) list functionality      *********/
   /*********************************************************/
@@ -1136,7 +1178,7 @@
     // also send search request to get the right messages
     if (this.env.search_request)
       add_url += '&_search='+this.env.search_request;
-      
+    
     this.select_mailbox(mbox);
 
     // load message list remotely
@@ -1233,7 +1275,10 @@
   this.move_messages = function(mbox)
     {
     // exit if no mailbox specified or if selection is empty
-    var selection = this.message_list.get_selection();
+    var selection = 0; 
+ 		if (this.message_list != null)  
+ 	      selection = this.message_list.get_selection(); 
+ 	    
     if (!mbox || !(selection.length || this.env.uid) || mbox==this.env.mailbox)
       return;
     
@@ -1270,7 +1315,11 @@
   this.permanently_remove_messages = function()
     {
     // exit if no mailbox specified or if selection is empty
-    var selection = this.message_list.get_selection();
+      var selection = 0; 
+	    if (this.message_list != null)  
+	    {  
+	      selection = this.message_list.get_selection(); 
+	    } 
     if (!(selection.length || this.env.uid))
       return;
     
@@ -1300,7 +1349,10 @@
   this.delete_messages = function()
     {
     // exit if no mailbox specified or if selection is empty
-    var selection = this.message_list.get_selection();
+    var selection = 0; 
+	  if (this.message_list != null)  
+	    selection = this.message_list.get_selection(); 
+	    
     if (!(selection.length || this.env.uid))
       return;
 
@@ -1803,9 +1855,18 @@
     {
     if (value && mbox)
       {
-      this.message_list.clear();
-      this.set_busy(true, 'searching');
-      this.http_request('search', '_search='+value+'&_mbox='+mbox, true);
+        if(this.task=='mail')
+        {
+          this.message_list.clear();
+          this.set_busy(true, 'searching');
+          this.http_request('search', '_search='+value+'&_mbox='+mbox, true);
+        }
+        else if(this.task=='addressbook')
+        {
+          this.contact_list.clear();
+          this.set_busy(true, 'searching');
+          this.http_request('search', '_search='+value+'&_mbox='+mbox, true);
+        }
       }
     return true;
     };
@@ -2056,7 +2117,42 @@
   /*********************************************************/
   /*********         address book methods          *********/
   /*********************************************************/
+  // move selected messages to the specified mailbox
+  this.move_contacts = function(mbox)
+    {
+    // if trying to move to all mbox - stop
+    if(mbox == 'all')
+      return;
+    // exit if no mailbox specified or if selection is empty
+    var selection = 0; 
+ 		if (this.contact_list != null)  
+ 	    {  
+ 	      selection = this.contact_list.get_selection(); 
+ 	    } 
+    if (!mbox || !(selection.length || this.env.cid) || mbox==this.env.mbox)
+      return;
+    
+    var a_cids = new Array();
+    
+    
+    if (this.env.cid)
+      a_cids[a_uids.length] = this.env.cid;
+    else
+      {
+        var id;
+        for (var n=0; n<selection.length; n++)
+          {
+          id = selection[n];
+          a_cids[a_cids.length] = id;
+          }
+      }
+      // show wait message
+      lock = true;
+      this.set_busy(true, 'movingmessage');
 
+    // send request to server
+    this.http_request('moveto', '_cid='+a_cids.join(',')+'&_target_mbox='+urlencode(mbox) , true);
+    };
 
   this.contactlist_keypress = function(list)
     {
@@ -2067,33 +2163,61 @@
 
   this.contactlist_select = function(list)
     {
-      var id, frame;
-      if (id = list.get_single_selection())
-        this.load_contact(id, 'show');
-      else if (frame = document.getElementById(this.env.contentframe))
-        frame.style.visibility = 'hidden';
-
-      this.enable_command('edit', id?true:false);
-
-      if (list.selection.length)
-        this.enable_command('delete', 'compose', true);
-
-      return false; 
+      if(!this.drag_active)
+      {
+          var id, frame;
+          //if (id = list.get_single_selection())
+          //  this.load_contact(id, 'show');
+            
+          //else if (frame = document.getElementById(this.env.contentframe))
+          //  frame.style.visibility = 'hidden';
+          
+          this.enable_command('edit', id?true:false);
+    
+          if (list.selection.length)
+            this.enable_command('delete', 'compose', true);
+    
+          return false; 
+        }
     };
-
-
-  this.list_contacts = function(page)
+    
+    this.contactlist_dbl_click = function(list)
     {
+          var id, frame;
+          if (id = list.get_single_selection())
+            this.load_contact(id, 'show');
+            
+          else if (frame = document.getElementById(this.env.contentframe))
+            frame.style.visibility = 'hidden';
+          
+          this.enable_command('edit', id?true:false);
+    
+          if (list.selection.length)
+            this.enable_command('delete', 'compose', true);
+    
+          return false; 
+    };
+    
+    
+  this.list_contacts = function(mbox, page, sort)
+    {
     var add_url = '';
     var target = window;
+     // clear message list first
+    this.contact_list.clear();
     
     if (page && this.current_page==page)
       return false;
-
+    
+    if(mbox != 'all')
+      this.enable_command('delete', false);
+    
+    this.select_groupbox(mbox);
+    
     // load contacts remotely
     if (this.gui_objects.contactslist)
       {
-      this.list_contacts_remote(page);
+      this.list_contacts_remote(mbox);
       return;
       }
 
@@ -2102,20 +2226,25 @@
       target = window.frames[this.env.contentframe];
       add_url = '&_framed=1';
       }
-
-    this.set_busy(true, 'loading');
-    target.location.href = this.env.comm_path+(page ? '&_page='+page : '')+add_url;
+      
+      this.set_busy(true, 'loading');
+      target.location.href = this.env.comm_path+'&_mbox='+urlencode(mbox)+(page ? '&_page='+page : '')+add_url;
     };
 
 
   // send remote request to load contacts list
-  this.list_contacts_remote = function(page)
+  this.list_contacts_remote = function(mbox, page)
     {
     // clear message list first
     this.contact_list.clear();
-
+      
     // send request to server
-    var url = page ? '&_page='+page : '';
+    if(page)
+      var url = page ? '&_page='+page : '';
+    
+    if(mbox)
+      var url = mbox ? '&_mbox='+mbox : '';
+    
     this.set_busy(true, 'loading');
     this.http_request('list', url, true);
     };
@@ -2148,9 +2277,40 @@
     {
     // exit if no mailbox specified or if selection is empty
     var selection = this.contact_list.get_selection();
-    if (!(selection.length || this.env.cid) || !confirm(this.get_label('deletecontactconfirm')))
-      return;
+      if(this.env.mbox != 'all')
+      {
+        if (!(selection.length || this.env.cid) || !confirm(this.get_label('deletecontactgroupconfirm')))
+        return;
+      }
+      else
+      {
+        if (!(selection.length || this.env.cid) || !confirm(this.get_label('deletecontactconfirm')))
+        return;
+      }
+    
+    var a_cids = new Array();
+    
+    if (this.env.cid)
+      a_cids[a_cids.length] = this.env.cid;
+    else
+      {
+      var id;
+      for (var n=0; n<selection.length; n++)
+        {
+        id = selection[n];
+        a_cids[a_cids.length] = id;
+        }
+      }
       
+    this.set_busy(true, 'loading');
+    // send request to server
+    this.http_request('delete', '_cid='+a_cids.join(',')+'&_mbox='+this.env.mbox+'&_from='+(this.env.action ? this.env.action : ''));
+    return true;
+    };
+
+  this.remove_contact_row = function(){
+  
+    var selection = this.contact_list.get_selection();
     var a_cids = new Array();
 
     if (this.env.cid)
@@ -2172,13 +2332,35 @@
         elm.style.visibility = 'hidden';
         }
       }
+  }
+    // add row to contacts list
+  this.add_contact_row = function(cid, cols)
+    {
+    if (!this.gui_objects.contactslist || !this.gui_objects.contactslist.tBodies[0])
+      return false;
+  
+    var tbody = this.gui_objects.contactslist.tBodies[0];
+    var rowcount = tbody.rows.length;
+    var even = rowcount%2;
+    
+    var row = document.createElement('TR');
+    row.id = 'rcmrow'+cid;
+    row.className = 'contact '+(even ? 'even' : 'odd');
+    
+    if (this.contact_list.in_selection(cid))
+      row.className += ' selected';
 
-    // send request to server
-    this.http_request('delete', '_cid='+a_cids.join(',')+'&_from='+(this.env.action ? this.env.action : ''));
-    return true;
+    // add each submitted col
+    for (var c in cols)
+      {
+      col = document.createElement('TD');
+      col.className = String(c).toLowerCase();
+      col.innerHTML = cols[c];
+      row.appendChild(col);
+      }
+    
+    this.contact_list.insert_row(row);
     };
-
-
   // update a contact record in the list
   this.update_contact_row = function(cid, cols_arr)
     {
@@ -2242,6 +2424,212 @@
 
 
   /*********************************************************/
+  /*********          vcard methods                *********/
+  /*********************************************************/
+  
+  // load vcard upload form
+  this.vcard_form = function(action)
+    {
+    var add_url = '';
+    var target = window;
+    if (this.env.contentframe && window.frames && window.frames[this.env.contentframe])
+      {
+      add_url = '&_framed=1';
+      target = window.frames[this.env.contentframe];
+      document.getElementById(this.env.contentframe).style.visibility = 'inherit';
+      }
+    else
+      return false;
+
+    if (action == 'vcard'){
+      target.location.href = this.env.comm_path+'&_action='+action+add_url;
+      }
+    return true;
+    };
+  
+   // upload attachment file
+  this.upload_vcard = function(form)
+    {    
+    for (var n=0; n<form.elements.length; n++)
+        {
+        
+          if(form.elements[n].name == '_action' )
+            $action = form.elements[n].value;
+        
+          if(form.elements[n].type=='file')
+            $file = form.elements[n].value;
+        
+        }
+        
+      if($file)
+      {
+
+          var add_url = '';
+          var target = window;
+          var frame_name = 'contact-frame';
+    
+          form.target = frame_name;
+          form.action = this.env.comm_path+'&_action=vcard'+add_url;
+          form.submit();
+      }else{
+        this.display_message('No file selected!', 'error');
+      }
+    };
+    
+    
+    
+    /*********************************************************/
+  /*********        groupbox methods               *********/
+  /*********************************************************/
+    this.show_group_form = function(act)
+    {
+    
+    if (!this.gui_objects.addgroupform)
+      return false;
+    
+    var elm, list;
+    if (elm = this.gui_objects.addgroupform)
+      {
+        elm.style.visibility = act ? 'visible' : 'hidden';
+      }
+      
+    // clear upload form
+    if (!act && this.gui_objects.addgroupform)
+      this.gui_objects.addgroupform.reset();
+    
+    return true;  
+    
+    };
+    
+  this.remove_group = function(mbox){
+      if (confirm(this.get_label('deletegroupfolderconfirm')))
+      {
+        if(mbox && mbox != 'all' && mbox != 'last_imported'){
+        
+          this.set_busy(true, 'loading');
+          url = '_folder='+urlencode(mbox)+'&_do=remove';
+          this.http_request('groupfolder',url,true);
+        
+        }else{
+          alert('can\'t delete this group box');
+        }
+      }
+  }
+  
+  this.addgroupfolder = function(form){
+    if (elm = this.gui_objects.addgroupform)
+        elm.style.visibility = 'hidden';
+    
+    for (var n=0; n<form.elements.length; n++)
+        {
+          if(form.elements[n].name == 'addgroup' )
+            added_group = form.elements[n].value;
+        }
+        
+    if(added_group)
+    {
+      this.set_busy(true, 'loading'); 
+      url = '_folder='+urlencode(added_group)+'&_do=add';
+      this.http_request('groupfolder',url,true);
+    }
+    else
+      this.display_message('No Input!', 'error');
+  }
+  
+  this.altergrouplist = function(folder,task ,list){
+    if(task == 'add')
+      this.add_group_rows(list);
+    else if(task == 'remove')
+    {
+      var list = this.gui_objects.groupboxlist.getElementsByTagName("li");
+      for (i=0;i<list.length;i++)
+        if (list[i].id == folder.toLowerCase())
+          this.gui_objects.groupboxlist.removeChild(list[i]);
+        
+      this.select_groupbox('all');
+      this.list_contacts(this.env.mbox);
+    }
+  };
+  
+  
+  this.add_group_rows = function(list){
+    var grouplist = this.gui_objects.groupboxlist.getElementsByTagName("li");
+    // remove all previous nodes
+    // for (i=0;i<grouplist.length;i++)
+    //      this.gui_objects.groupboxlist.removeChild(grouplist[i]);
+    this.gui_objects.groupboxlist.innerHTML = unescape(list);
+  }
+  // onmouseup handler for mailboxlist item
+  this.groupbox_mouse_up = function(mbox)
+    {
+    if (this.drag_active)
+      {
+      this.unfocus_groupbox(mbox);
+      this.command('moveto', mbox);
+      }
+    else
+      {
+      this.command('list', mbox);
+      }
+    return false;
+    };
+    
+    
+  this.get_groupbox_li = function(mbox)
+    {
+    if (this.gui_objects.groupboxlist)
+      {
+      mbox = String((mbox ? mbox : this.env.mbox)).toLowerCase().replace(this.mbox_expression, '');
+      return document.getElementById('rcmbx'+mbox);
+      }
+    
+    return null;
+    };
+    
+  this.focus_groupbox = function(mbox)
+    {
+    var mbox_li;
+    if (this.drag_active && mbox != this.env.mbox && (mbox_li = this.get_groupbox_li(mbox)))
+      this.set_classname(mbox_li, 'droptarget', true);
+    }
+    
+  this.unfocus_groupbox = function(mbox)
+    {
+    var mbox_li;
+    if (this.drag_active && (mbox_li = this.get_groupbox_li(mbox)))
+      this.set_classname(mbox_li, 'droptarget', false);
+    }
+  // mark a mailbox as selected and set environment variable
+  this.select_groupbox = function(mbox)
+    {
+    if (this.gui_objects.groupboxlist )
+      {      
+      var item, reg, text_obj;      
+      var current_li = this.get_groupbox_li();
+      var mbox_li = this.get_groupbox_li(mbox);
+
+      if (current_li)
+        {
+        this.set_classname(current_li, 'selected', false);
+        this.set_classname(current_li, 'unfocused', false);
+        }
+
+      if (mbox_li || this.env.mbox == mbox)
+        {
+        this.set_classname(mbox_li, 'unfocused', false);
+        this.set_classname(mbox_li, 'selected', true);
+        }
+      }
+      
+    this.env.mbox = mbox;
+
+    if(mbox != 'all' && mbox != 'last_imported')
+      this.enable_command('removegroup', 'editgroup', true);
+    else
+      this.enable_command('removegroup', 'editgroup', false);
+    };
+    
+  /*********************************************************/
   /*********        user settings methods          *********/
   /*********************************************************/
 
@@ -2621,7 +3009,35 @@
   /*********           GUI functionality           *********/
   /*********************************************************/
 
-
+  this.list_display_details = function(list)
+    {
+        // get subjects of selectedd messages
+        var names = '';
+        var c, subject, obj;
+        for(var n=0; n<list.selection.length; n++)
+        {
+            if (n>12)  // only show 12 lines
+            {
+              names += '...';
+              break;
+            }
+      
+            if (list.rows[list.selection[n]].obj)
+            {
+              obj = list.rows[list.selection[n]].obj;
+              subject = '';
+      
+              for(c=0; c<obj.childNodes.length; c++)
+                if (!subject && obj.childNodes[c].nodeName=='TD' && obj.childNodes[c].firstChild && obj.childNodes[c].firstChild.nodeType==3)
+                {
+                  subject = obj.childNodes[c].firstChild.data;
+                  names += (subject.length > 50 ? subject.substring(0, 50)+'...' : subject) + '<br />';
+                }
+            }
+          }
+          list.draglayer_display = names; 
+      }
+      
   // eable/disable buttons for page shifting
   this.set_page_buttons = function()
     {
@@ -2830,8 +3246,8 @@
     
     this.env.mailbox = mbox;
     };
+  
 
-
   // for reordering column array, Konqueror workaround
   this.set_message_coltypes = function(coltypes) 
   { 
@@ -2973,37 +3389,6 @@
       }
     };
 
-
-  // add row to contacts list
-  this.add_contact_row = function(cid, cols, select)
-    {
-    if (!this.gui_objects.contactslist || !this.gui_objects.contactslist.tBodies[0])
-      return false;
-    
-    var tbody = this.gui_objects.contactslist.tBodies[0];
-    var rowcount = tbody.rows.length;
-    var even = rowcount%2;
-    
-    var row = document.createElement('TR');
-    row.id = 'rcmrow'+cid;
-    row.className = 'contact '+(even ? 'even' : 'odd');
-    
-    if (this.contact_list.in_selection(cid))
-      row.className += ' selected';
-
-    // add each submitted col
-    for (var c in cols)
-      {
-      col = document.createElement('TD');
-      col.className = String(c).toLowerCase();
-      col.innerHTML = cols[c];
-      row.appendChild(col);
-      }
-    
-    this.contact_list.insert_row(row);
-    };
-
-
   this.toggle_editor = function(checkbox, textElementName)
     {
     var ischecked = checkbox.checked;
@@ -3071,7 +3456,7 @@
 
       if (lock)
         this.set_busy(true);
-
+      
       request_obj.__lock = lock ? true : false;
       request_obj.__action = action;
       request_obj.onerror = function(o){ rcube_webmail_client.http_error(o); };
@@ -3238,147 +3623,6 @@
   }  // end object rcube_webmail
 
 
-
-/**
- * Class for sending HTTP requests
- * @constructor
- */
-function rcube_http_request()
-  {
-  this.url = '';
-  this.busy = false;
-  this.xmlhttp = null;
-
-
-  // reset object properties
-  this.reset = function()
-    {
-    // set unassigned event handlers
-    this.onloading = function(){ };
-    this.onloaded = function(){ };
-    this.oninteractive = function(){ };
-    this.oncomplete = function(){ };
-    this.onabort = function(){ };
-    this.onerror = function(){ };
-    
-    this.url = '';
-    this.busy = false;
-    this.xmlhttp = null;
-    }
-
-
-  // create HTMLHTTP object
-  this.build = function()
-    {
-    if (window.XMLHttpRequest)
-      this.xmlhttp = new XMLHttpRequest();
-    else if (window.ActiveXObject)
-      this.xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
-    else
-      {
-      
-      }
-    }
-
-  // send GET request
-  this.GET = function(url)
-    {
-    this.build();
-
-    if (!this.xmlhttp)
-      {
-      this.onerror(this);
-      return false;
-      }
-
-    var ref = this;
-    this.url = url;
-    this.busy = true;
-
-    this.xmlhttp.onreadystatechange = function(){ ref.xmlhttp_onreadystatechange(); };
-    this.xmlhttp.open('GET', url);
-    this.xmlhttp.send(null);
-    };
-
-
-  this.POST = function(url, body, contentType)
-    {
-    // default value for contentType if not provided
-    contentType = typeof(contentType) != 'undefined' ?
-      contentType : 'application/x-www-form-urlencoded';
-
-    this.build();
-    
-    if (!this.xmlhttp)
-    {
-       this.onerror(this);
-       return false;
-    }
-
-    var ref=this;
-    this.url = url;
-    this.busy = true;
-    
-    this.xmlhttp.onreadystatechange = function() { ref.xmlhttp_onreadystatechange(); };
-    this.xmlhttp.open('POST', url, true);
-    this.xmlhttp.setRequestHeader('Content-Type', contentType);
-    this.xmlhttp.send(body);
-    };
-
-
-  // handle onreadystatechange event
-  this.xmlhttp_onreadystatechange = function()
-    {
-    if(this.xmlhttp.readyState == 1)
-      this.onloading(this);
-
-    else if(this.xmlhttp.readyState == 2)
-      this.onloaded(this);
-
-    else if(this.xmlhttp.readyState == 3)
-      this.oninteractive(this);
-
-    else if(this.xmlhttp.readyState == 4)
-      {
-      try {
-        if (this.xmlhttp.status == 0)
-          this.onabort(this);
-        else if(this.xmlhttp.status == 200)
-          this.oncomplete(this);
-        else
-          this.onerror(this);
-
-        this.busy = false;
-        }
-      catch(err)
-        {
-        this.onerror(this);
-        this.busy = false;
-        }
-      }
-    }
-
-  // getter method for HTTP headers
-  this.get_header = function(name)
-    {
-    return this.xmlhttp.getResponseHeader(name);
-    };
-
-  this.get_text = function()
-    {
-    return this.xmlhttp.responseText;
-    };
-
-  this.get_xml = function()
-    {
-    return this.xmlhttp.responseXML;
-    };
-
-  this.reset();
-  
-  }  // end class rcube_http_request
-
-
 // helper function to call the init method with a delay
 function call_init(o)
   {
Index: program/js/list.js
===================================================================
--- program/js/list.js	(revision 360)
+++ program/js/list.js	(working copy)
@@ -32,10 +32,13 @@
   this.rows = [];
   this.selection = [];
   
+  this.draglayer_display = "";
+   
   this.multiselect = false;
   this.draggable = false;
   this.keyboard = false;
   
+ 
   this.dont_select = false;
   this.drag_active = false;
   this.last_selected = 0;
@@ -117,6 +120,7 @@
  */
 clear: function()
 {
+  this.selection = new Array();
   var tbody = document.createElement('TBODY');
   this.list.insertBefore(tbody, this.list.tBodies[0]);
   this.list.removeChild(this.list.tBodies[1]);
@@ -442,8 +446,6 @@
 
   this.selection = new Array();    
 },
-
-
 /**
  * Getter for the selection array
  */
@@ -575,33 +577,8 @@
   
     if (!this.draglayer)
       this.draglayer = new rcube_layer('rcmdraglayer', {x:0, y:0, width:300, vis:0, zindex:2000});
-  
-    // get subjects of selectedd messages
-    var names = '';
-    var c, subject, obj;
-    for(var n=0; n<this.selection.length; n++)
-    {
-      if (n>12)  // only show 12 lines
-      {
-        names += '...';
-        break;
-      }
-
-      if (this.rows[this.selection[n]].obj)
-      {
-        obj = this.rows[this.selection[n]].obj;
-        subject = '';
-
-        for(c=0; c<obj.childNodes.length; c++)
-          if (!subject && obj.childNodes[c].nodeName=='TD' && obj.childNodes[c].firstChild && obj.childNodes[c].firstChild.nodeType==3)
-          {
-            subject = obj.childNodes[c].firstChild.data;
-            names += (subject.length > 50 ? subject.substring(0, 50)+'...' : subject) + '<br />';
-          }
-      }
-    }
-
-    this.draglayer.write(names);
+    
+    this.draglayer.write(this.draglayer_display);
     this.draglayer.show(1);
 
     this.drag_active = true;
@@ -626,7 +603,9 @@
 drag_mouse_up: function(e)
 {
   document.onmousemove = null;
-
+  
+  this.draglayer_display = "";
+  
   if (this.draglayer && this.draglayer.visible)
     this.draglayer.show(0);
 
